Skip to navigation

Create a notification definition

View as Markdown

Creates a notification definition. If a filter rule is specified, it will be evaluated to see if the notification definition is qualified to handle the incoming events during runtime. If the notification is qualified, it will send the email and invoke the callout if it has an email template or a callout.

This operation supports creating notification definitions for all event types:

You must specify either eventCategory or eventTypeName, but not both at the same time.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Request

The request body used to create the notification definition.
namestringRequired<=255 characters
The name of the notification definition, unique per communication profile.
activebooleanOptionalDefaults to true

The status of the notification definition. The default value is true.

associatedAccountstringOptional

The account on which the histories of this notification will be displayed. The associated account does not enforce where the merge fields come from. Available values are as follows:

  • Account.Id: ID of the primary customer account related to the notification. It is also the default value.
  • ParentAccount.Id: this option is available only if you have Customer Hierarchy enabled for your tenant.
  • SubscriptionOwnerAccount.Id: this option is available if the base object of the notification is Order Action.

Note: before specifying this field, we recommend that you use Data Source to check the available types of accounts for the current notification.

calloutobjectOptional

If this field is specified, Zuora will create a new callout template when creating the notification definition and associate the template with the notification definition.

You cannot specify the calloutTemplateIds and callout fields at the same time.

For more information about callout templates, see Manage callout templates.

Variant:
Callout - without authenticationobjectRequired
Common information for callout notifications.
calloutActivebooleanOptionalDefaults to false

The status of the callout action. The default value is false.

calloutTemplateIdslist of stringsOptional

List of callout template IDs that the notification definition is associated with.

You cannot specify the calloutTemplateIds and callout fields at the same time.

For more information about callout templates, see Manage callout templates.

communicationProfileIdstringOptional

The ID of the communication profile that the notification definition is associated with.

You can use the Query Action to get the communication profile Id. See the following request sample:

{ "queryString": "select Id, ProfileName from CommunicationProfile" }

If you do not pass the communicationProfileId, notification service will be automatically added to the ‘Default Profile’.

If you want to associate the notification definition with multiple communication profiles, use the communicationProfileIds field, which overrides this field.

communicationProfileIdslist of stringsOptional

List of communication profile IDs that the notification definition is associated with.

This field overrides the communicationProfileId field.

descriptionstringOptional<=255 characters
The description of the notification definition.
emailActivebooleanOptionalDefaults to false

The status of the email action. The default value is false.

emailTemplateIdstringOptionalformat: "uuid"

The ID of the email template. If emailActive is true, an email template is required. And EventType of the email template MUST be the same as the eventType.

eventCategorydoubleOptional

The event category code for a standard event, on which the notification definition is created.

This field is required when creating notification definitions for standard events.

For the list of supported standard event category codes, see Standard event category code for events and notifications.

eventTypeNamestringOptional>=1 character

The name of the event that the notification definition is based on.

This field is required when creating notification definitions for Zuora custom events, custom events, or custom scheduled events.

If this field is provided, you can specify the event namespace in the eventTypeNamespace field.

eventTypeNamespaceenumOptionalDefaults to user.notification

The namespace of the eventTypeName field. It indicates who created the event and which namespace the event is assigned to.

Supported values are as follows:

  • com.zuora.notification: events that are created by Zuora. This value applies to Zuora custom events.
  • user.notification: events that are created by tenant users. This value applies to custom events and custom scheduled events. This is the default value.

For example, if you want to create a notification definition on the OrderActionProcessed event, which is a Zuora custom event, you must specify com.zuora.notification for this field.

Allowed values:
filterRuleobjectOptional
filterRuleParamsmap from strings to stringsOptional
The parameter values used to configure the filter rule.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Response

OK
activebooleanOptional

The status of the notification definition. The default value is true.

associatedAccountstringOptional
The account on which the histories of this notification will be displayed. The associated account does not enforce where the merge fields come from.
calloutobjectOptional
calloutActivebooleanOptional

The status of the callout action. The default value is false.

calloutTemplateIdslist of stringsOptional
List of callout template IDs that the notification definition is associated with.
communicationProfileIdstringOptionalformat: "uuid"

The ID of the communication profile that the notification definition is associated with.

If the notification definition is associated with multiple communication profiles, see communicationProfileIds for all associated communication profile IDs.

communicationProfileIdslist of stringsOptional
List of communication profile IDs that the notification definition is associated with.
createdBystringOptionalformat: "uuid"
The ID of the user who created the notification definition.
createdOnstringOptional

The time when the notification definition was created. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00

descriptionstringOptional<=255 characters
Description of the notification definition
emailActivebooleanOptional

The status of the email action. The default value is false.

emailTemplateIdstringOptionalformat: "uuid"
The ID of the email template. In the request, there should be at least one email template or callout.
eventCategorydoubleOptional

The event category code for a standard event, on which the notification definition is created.

This field is available only if the notification definition is based on a standard event.

For the list of supported standard event category codes, see Standard event category code for events and notifications.

eventIdstringOptionalformat: "uuid"
The ID of the event that the notification definition is based on. This field is available only if the notification definition is based on a standard event.
eventTypeNamestringOptional>=1 character
The name of the event that the notification definition is based on. This field is available only if the notification definition is based on a Zuora custom event, custom event, or custom scheduled event.
eventTypeNamespaceenumOptional

The namespace of the eventTypeName field. It indicates who created the event and which namespace the event is assigned to.

Supported values are as follows:

  • com.zuora.notification: events that are created by Zuora. This value applies to Zuora custom events.
  • user.notification: events that are created by tenant users. This value applies to custom events and custom scheduled events.

This field is available only if the notification definition is based on a Zuora custom event, custom event, or custom scheduled event.

Allowed values:
filterRuleobjectOptional
filterRuleParamsmap from strings to stringsOptional
The parameter values used to configure the filter rule.
idstringOptionalformat: "uuid"
The ID associated with this notification definition.
namestringOptional<=255 characters
The name of the notification definition.
updatedBystringOptionalformat: "uuid"
The ID of the user who updated the notification definition.
updatedOnstringOptional

The time when the notification was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00

Errors

400
Bad Request Error
404
Not Found Error
405
Method Not Allowed Error
415
Unsupported Media Type Error
500
Internal Server Error